func btnZoomEvent(_ sender: Any) {
        isFromZoomBtn = true
        zoomCount += 1
        var maxScaleOfSelectedItem = self.scrollView.maximumZoomScale
        var isSelcted = false
        if let selectedInfographicView = self.selectedInfographicView {
            maxScaleOfSelectedItem = min(self.scrollView.frame.width/selectedInfographicView.frame.width, self.scrollView.frame.height/selectedInfographicView.frame.height)
            isSelcted = true
        }
        let zoomScale = ((self.scrollView.maximumZoomScale-self.scrollView.minimumZoomScale)/5)
        if (maxScaleOfSelectedItem < self.scrollView.maximumZoomScale) || isSelcted {
            if maxScaleOfSelectedItem > self.scrollView.zoomScale {
                isZoomButtonTapped = true
                let newMaxScale = min(maxScaleOfSelectedItem, self.scrollView.maximumZoomScale)
                self.scrollView.setZoomScale(newMaxScale, animated: true)
            }else {
                if self.isFromInfographicZoom {
                    if self.selectedInfographicView != nil {
                        self.zoomView.frame.origin.y = -self.selectedInfographicView.frame.origin.yself.scrollView.zoomScale
                    }
                    self.isFromInfographicZoom = false
                }else {
                    let newMaxScale = CGFloat(Double(((zoomScale)CGFloat(zoomCount-1))+self.scrollView.minimumZoomScale).rounded(digits: 2))
                    self.scrollView.setZoomScale(newMaxScale, animated: true)
                }
            }
        }else {
            let newMaxScale = CGFloat(Double(((zoomScale)*CGFloat(zoomCount-1))+self.scrollView.minimumZoomScale).rounded(digits: 2))
            self.scrollView.setZoomScale(newMaxScale, animated: true)
        }
    }
    
    
    
    func adjustFrameToCenter() {
            self.hideGridView()
            var frameToCenter = self.zoomView.frame
            // center horizontally
            if frameToCenter.size.width <= self.scrollView.bounds.width {
                frameToCenter.origin.x = (self.scrollView.bounds.width - frameToCenter.size.width) / 2
            }else {
                if isZoomButtonTapped {
                    frameToCenter.origin.x = 0
                }else {
                    frameToCenter.origin.x = min(frameToCenter.origin.x, 0)
                }
            }
    
            // center vertically
            if frameToCenter.size.height.rounded() <= self.scrollView.bounds.height {
                frameToCenter.origin.y = (self.scrollView.bounds.height - frameToCenter.size.height) / 2
            }else {
                if isZoomButtonTapped {
                    frameToCenter.origin.y = 0
                }else {
                    frameToCenter.origin.y = min(frameToCenter.origin.y, 0)
                }
            }
            if !isDownScale {
                let zoomScale = ((self.scrollView.maximumZoomScale-self.scrollView.minimumZoomScale)/5)
                switch self.scrollView.zoomScale {
                case self.scrollView.minimumZoomScale:
                    self.zoomCount = 1
                case self.scrollView.minimumZoomScale...CGFloat(Double((zoomScale1)+self.scrollView.minimumZoomScale).rounded(digits: 2)):
                    self.zoomCount = 2
                case CGFloat(Double((zoomScale1)+self.scrollView.minimumZoomScale).rounded(digits: 2))...CGFloat(Double((zoomScale2)+self.scrollView.minimumZoomScale).rounded(digits: 2)):
                    self.zoomCount = 3
                case CGFloat(Double((zoomScale2)+self.scrollView.minimumZoomScale).rounded(digits: 2))...CGFloat(Double((zoomScale3)+self.scrollView.minimumZoomScale).rounded(digits: 2)):
                    self.zoomCount = 4
                case CGFloat(Double((zoomScale3)+self.scrollView.minimumZoomScale).rounded(digits: 2))...CGFloat(Double((zoomScale4)+self.scrollView.minimumZoomScale).rounded(digits: 2)):
                    self.zoomCount = 5
                case CGFloat(Double((zoomScale4)+self.scrollView.minimumZoomScale).rounded(digits: 2))...self.scrollView.maximumZoomScale:
                    self.zoomCount = 6
                default:
                    self.zoomCount = 1
                }
            }else {
                isDownScale = false
            }
            if isZoomButtonTapped {
                isZoomButtonTapped = false
                let maxYPos = frameToCenter.height - self.scrollView.frame.height
                let maxXPos = frameToCenter.width - self.scrollView.frame.width

                if let selectedInfographicView = self.selectedInfographicView {
                    let maxX = max(self.scrollView.frame.width - ((selectedInfographicView.frame.maxX-selectedInfographicView.frame.origin.x)self.scrollView.zoomScale), 0)/2
                    let maxY = max(self.scrollView.frame.height - ((selectedInfographicView.frame.maxY-selectedInfographicView.frame.origin.y)self.scrollView.zoomScale), 0)/2
                    if self.isFromInfographicZoom {
                        self.scrollView.contentOffset = CGPoint(x: max(min((selectedInfographicView.frame.origin.xself.scrollView.zoomScale)-maxX, maxXPos), 0), y: 0)
                    }else {
                        self.scrollView.contentOffset = CGPoint(x: max(min((selectedInfographicView.frame.origin.xself.scrollView.zoomScale)-maxX, maxXPos), 0), y: max(min((selectedInfographicView.frame.origin.yself.scrollView.zoomScale)-maxY, maxYPos), 0))
                    }
                }
            }
            if self.isFromInfographicZoom {
                if self.selectedInfographicView != nil {
                    let yPos = -self.selectedInfographicView.frame.origin.yself.scrollView.zoomScale
                    frameToCenter.origin.y = yPos <= 0 ? yPos : 0
                }
                self.isFromInfographicZoom = false
            }
            self.zoomView.frame = frameToCenter
        }


    